#include "ehs/system/BaseSemaphore.h"

namespace ehs
{
	BaseSemaphore::BaseSemaphore()
		: initial(0)
	{
	}

	BaseSemaphore::BaseSemaphore(Str_8 name, const UInt_32 initial)
		: name(std::move(name)), initial(initial)
	{
	}

	BaseSemaphore::BaseSemaphore(const UInt_32 initial)
		: initial(initial)
	{
	}

	BaseSemaphore::BaseSemaphore(BaseSemaphore&& sem) noexcept
		: name(std::move(sem.name)), initial(sem.initial)
	{
	}

	BaseSemaphore::BaseSemaphore(const BaseSemaphore& sem)
		: name(sem.name), initial(sem.initial)
	{
	}

	BaseSemaphore& BaseSemaphore::operator=(const BaseSemaphore& sem)
	{
		if (this == &sem)
			return *this;

		name = sem.name;
		initial = sem.initial;

		return *this;
	}

	BaseSemaphore& BaseSemaphore::operator=(BaseSemaphore&& sem) noexcept
	{
		if (this == &sem)
			return *this;

		name = std::move(sem.name);
		initial = sem.initial;

		return *this;
	}

	Str_8 BaseSemaphore::GetName() const
	{
		return name;
	}

	UInt_32 BaseSemaphore::GetInitial() const
	{
		return initial;
	}
}